﻿Public Class Form1
    '폼이 로드 될때 호출됨
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load

        'DataGridView를 선택하면 전체 한줄이 선택되게 됩니다. 
        DataGridView1.SelectionMode = DataGridViewSelectionMode.FullRowSelect

        '컬럼 2개를 생성하고 각각의 이름을 정해줍니다. DataGridView1의 상단에 위치하게 됩니다. 
        DataGridView1.ColumnCount = 2
        DataGridView1.Columns(0).Name = "이름"
        DataGridView1.Columns(1).Name = "주소"
    End Sub

    '추가 버튼 클릭시 호출됨
    Private Sub add_Button_Click(sender As Object, e As EventArgs) Handles add_Button.Click

        '공백을 입력할 수 없도록 에러처리 
        If name_TextBox.Text = "" Or address_TextBox.Text = "" Then
            MsgBox("데이터를 입력하세요")
            Return
        End If

        'DataGridView의 한 줄에 추가될 데이터를 배열에 넣습니다.
        Dim row As String() = New String() {name_TextBox.Text, address_TextBox.Text}

        '배열을 DataGridView에 추가합니다.
        DataGridView1.Rows.Add(row)

        '데이터가 입력되었던 텍스트박스를 비웁니다.
        name_TextBox.Text = ""
        address_TextBox.Text = ""

    End Sub

    'DataGridView1의 셀을 클릭시 호출됩니다. 
    Private Sub DataGridView1_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles DataGridView1.CellClick

        If (e.RowIndex > -1) And Not (DataGridView1.SelectedRows(0).Cells(0).Value = Nothing) Then
            'DataGridView1에서 선택된 행의 첫번째 셀의 값을 name_TextBox의 내용으로 합니다.
            name_TextBox.Text = DataGridView1.SelectedRows(0).Cells(0).Value.ToString

            'DataGridView1에서 선택된 행의 두번째 셀의 값을 address_TextBox의 내용으로 합니다.
            address_TextBox.Text = DataGridView1.SelectedRows(0).Cells(1).Value.ToString
        Else
            name_TextBox.Text = ""
            address_TextBox.Text = ""
        End If
    End Sub

    '업데이트 버튼 클릭시 호출됩니다.
    Private Sub update_Button_Click(sender As Object, e As EventArgs) Handles update_Button.Click
        DataGridView1.SelectedRows(0).Cells(0).Value = name_TextBox.Text
        DataGridView1.SelectedRows(0).Cells(1).Value = address_TextBox.Text
    End Sub

    '삭제 버튼 클릭시 호출됨
    Private Sub delete_Button_Click(sender As Object, e As EventArgs) Handles delete_Button.Click
        '삭제할 수 없는 셀인 경우 에러처리
        If DataGridView1.SelectedRows(0).Cells(0).Value = Nothing Then
            Return
        End If


        Dim msgResult As MsgBoxResult = MsgBox("삭제하시겠습니까?", MsgBoxStyle.YesNo)

        If msgResult = MsgBoxResult.Yes Then
            DataGridView1.Rows.RemoveAt(DataGridView1.SelectedRows(0).Index)

            name_TextBox.Text = ""
            address_TextBox.Text = ""

        End If

    End Sub
End Class